SystemOrganization addCategory: #SWA014!

Morph subclass: #SWA014Game
	instanceVariableNames: 'world maxSize numberOfEnemies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'M.V. 11/30/2016 23:15'!
open
	^self new spawnPlayer; spawnEnemy; openInWorld; yourself.
	! !

!SWA014Game methodsFor: 'deleting' stamp: 'M.V. 11/30/2016 22:56'!
destroyAllEntities
	self flag: 'TODO: delete this method; this method only helps us controlling all objects, we do not need anymore for tests'.
	
	self swaworld listOfEnemies do: 
	[:x| x delete].
	self swaworld listOfEnemies: Set new.

	self swaworld swaplayer delete.
	self swaworld swaplayer: nil.
	
	self swaworld delete.
	self swaworld: nil.! !

!SWA014Game methodsFor: 'game events' stamp: 'M.V. 11/30/2016 23:51'!
gameOver
	self destroyAllEntities.
	self delete.! !

!SWA014Game methodsFor: 'initialization' stamp: 'M.V. 11/30/2016 23:50'!
initialize
	super initialize.
	
	self swaworld: SWA014World new.
	self addMorph: self swaworld.
	self swaworld game: self.
	
	self clipSubmorphs: true.
	self extent: (World bounds corner x)@(World bounds corner y). "ActiveWorld extent"! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:26'!
maxSize
	^75.
	! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:27'!
maxSize: aNumber
	maxSize := aNumber.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/6/2016 10:24'!
numberOfEnemies
	^100.! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:25'!
numberOfEnemies: aNumber
	numberOfEnemies := aNumber.! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/6/2016 11:08'!
spawnEnemy
"spawns SWA014Enemys up to the specified number"
|enemy random r1 r2 r3|

1 to: (self numberOfEnemies)  do:
[:x|	
	enemy := SWA014Enemy new.
	random := Random new.
	r1 := random nextInt: self swaworld width.
	r2 := random nextInt: self swaworld height.
	r3 := random nextInt: (self maxSize).
	enemy position: (r1@r2).
	enemy bodysize: r3.	
	enemy swaworld: self swaworld.
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.
].! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/6/2016 11:09'!
spawnPlayer
	|newPlayer|
	newPlayer := SWA014Player new.
	newPlayer color: Color red.
	newPlayer bodysize: 60.
	newPlayer position: self swaworld center.
	newPlayer swaworld: self swaworld.		
	self swaworld swaplayer: newPlayer.
	self swaworld addMorph: newPlayer.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld
	^world.! !

!SWA014Game methodsFor: 'accessors' stamp: 'Tc 12/4/2016 21:26'!
swaworld: aWorld
	world := aWorld.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'bodysize speed id direction world currentStep maxAllowedSize minAllowedSize minAllowedSpeed maxAllowedSpeed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: 'bigNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:39'!
bigNumber
	^SmallInteger maxVal.! !

!SWA014Enemy methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:18'!
bigNumber: aNumber
	bigNumber := aNumber.! !

!SWA014Enemy methodsFor: 'movement' stamp: 'M.V. 11/30/2016 23:20'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."

calculateMovement: target
	super calculateMovement: target center.
	
	target bodysize >= self bodysize
	ifTrue:
	 [
		self direction: (0@0) - self direction.
	].
	! !

!SWA014Enemy methodsFor: 'vision' stamp: 'MV 12/6/2016 11:08'!
nearestEnemy
	|smallestDistance nearestEnemyobject allEnemies currentDistance|
	
	smallestDistance := (self bigNumber).
	nearestEnemyobject := self.
	
	allEnemies := Set new.
	allEnemies := self swaworld listOfEnemies copy.
	allEnemies add: self swaworld swaplayer.
	
	allEnemies do: 
	[:enemy| 
	currentDistance := self distanceTo: enemy center.
	(currentDistance  < smallestDistance)
	ifTrue: [smallestDistance := currentDistance.
			nearestEnemyobject := enemy.]
	] without: self.

	^nearestEnemyobject.! !

!SWA014Enemy methodsFor: 'override' stamp: 'M.V. 11/25/2016 01:19'!
step
	self currentStep > self stepNumber
	ifTrue:
	[
		self calculateMovement: self nearestEnemy.
		self moveAutomatically.
		self currentStep: 0.
	] 
	ifFalse:
	[
		self currentStep: self currentStep + 1.
	].
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 22:59'!
bodysize 
	^bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'Tc 12/4/2016 23:32'!
bodysize: x
	
	x < (self maxAllowedSize)
	ifTrue: 
	[
		x > (self minAllowedSize)
		ifTrue: 
		[
			bodysize := x.
		]
		ifFalse: 
		[
			bodysize := (self minAllowedSize).
		].		
	]
	ifFalse:
	[
		bodysize := (self maxAllowedSize).
	] .
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/25/2016 01:13'!
calculateMovement: target
	|directionVector deltaX deltaY distance|
		
	deltaX := (target x - self center x).
	deltaY := (target y - self center y).
	
	distance := self distanceTo: target.
	distance == 0 ifTrue: [distance := 1.]. "prevent us from dividing by zero"
	
	directionVector := ((deltaX/distance)@(deltaY/distance)).
	
	self direction: directionVector.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'M.V. 11/30/2016 23:16'!
checkForCollisions
	|radius listOfLivingThings|
	
	radius := self bodysize/2.	
	listOfLivingThings := Set new.
	listOfLivingThings := self swaworld listOfEnemies copy.
	listOfLivingThings add: self swaworld swaplayer.
	
	listOfLivingThings do:
	[	
		:enemy|
		(enemy ~~ self) ifTrue: 
		[
			(enemy bodysize < self bodysize) ifTrue: 
			[
				((self distanceTo: enemy center) < radius) ifTrue: 
				[
					self eat: enemy.
				]
			]
		]
	]! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'M.V. 11/25/2016 01:14'!
distanceTo: enemy
	^(((enemy x - self center x) raisedTo: 2)+
	((enemy y - self center y) raisedTo: 2)) sqrt. "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'M.V. 11/30/2016 23:17'!
eat: prey
	self bodysize: 2* (((self bodysize / 2) raisedTo: 2) + ((prey bodysize / 2) raisedTo: 2)) sqrt.

	self swaworld listOfEnemies: 
		(self swaworld listOfEnemies reject: [:enemy| enemy == prey]).
	(prey ~~ self swaworld swaplayer) 
	ifTrue: 
	[
		prey delete.
	]
	ifFalse: 
	[
		self swaworld game gameOver.
	].! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'M.V. 11/25/2016 00:37'!
initialize
	super initialize.
	self currentStep: 0.
	self speed: 60.
	self direction: (0@0).! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:32'!
maxAllowedSize
	^1000.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:32'!
maxAllowedSize: aNumber
	maxAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:11'!
maxAllowedSpeed
	^1000.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:12'!
maxAllowedSpeed: aNumber
	maxAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:31'!
minAllowedSize
	^10.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:33'!
minAllowedSize: aNumber
	minAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:15'!
minAllowedSpeed
	^1.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:13'!
minAllowedSpeed: aNumber
	minAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/6/2016 10:21'!
moveAutomatically
	self center: self center + (10 * (self direction)).! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:17'!
refreshSize
	self extent: self bodysize asPoint.
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'Tc 12/4/2016 23:33'!
speed: x

	x < (self maxAllowedSpeed) 
	ifTrue: 
	[
		x> (self minAllowedSpeed) 
		ifTrue: 
		[
			 speed := x.
		]
	 	ifFalse:
		[
			speed := (self minAllowedSpeed).
		].
	]
	ifFalse:
	[
		speed := (self maxAllowedSpeed).
	] .
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/18/2016 14:19'!
step
	self checkForCollisions.
	self refreshSize.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/30/2016 23:17'!
stepNumber
	"This is used to keep the stepTime up to date"
	
	self speed ~= 0
	ifTrue:
	[
		^10 * (self bodysize sqrt)  / self speed.	
	]
	ifFalse: 
	[
		^SmallInteger maxVal.	"Stops stepping"
	].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/6/2016 10:16'!
stepTime
	^100! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld: x
	world := x.! !

SWA014LivingThing subclass: #SWA014Player
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Player commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Player methodsFor: 'movement' stamp: 'MV 12/6/2016 10:22'!
moveAutomatically
	self swaworld center: self swaworld center - (10 * self direction).
	self center: self center + (10 * self direction).! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:42'!
number
	^number.! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:41'!
number: x
	number := x.! !

!SWA014Player methodsFor: 'override' stamp: 'M.V. 11/25/2016 11:16'!
step
	super step.
	self calculateMovement: World activeHand center.
	self moveAutomatically.! !

ImageMorph subclass: #SWA014World
	instanceVariableNames: 'worldSize listOfEnemies swaplayer game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'collisionHandling' stamp: 'MV 12/6/2016 11:11'!
checkForBorderCollisions
	|enemyListWithPlayer|
	
	enemyListWithPlayer:= listOfEnemies copy.
	enemyListWithPlayer add: self swaplayer.
	self flag: 'TODO: Be cautios. Now the method uses 5 as magical number. In general the constant should be determine by the stepping speed of our player, but the players speed is constant up to now'.
	
	enemyListWithPlayer do: 
	[:enemy | 
	(enemy bounds right > self bounds right) ifTrue:
	[
		(enemy ==  self swaplayer) ifTrue:
			[self right: enemy bounds right] ifFalse:
			[enemy  right: (self bounds right).].
	].
	
	(enemy bounds top < self bounds top) ifTrue: [enemy  top: (self bounds top).
	(enemy == self swaplayer) ifTrue:[self center: ((self center x)@(self center y-5))]].
	
	(enemy bounds left < self bounds left) ifTrue: [enemy  left: (self bounds left).
	(enemy == self swaplayer) ifTrue:[self center: ((self center x - 5)@(self center y))]].
	
	(enemy bounds bottom > self bounds bottom) ifTrue: [enemy  bottom: (self bounds bottom).
	(enemy == self swaplayer) ifTrue:[self center: ((self center x)@(self center y + 5))]].
	].! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'initialization' stamp: 'M.V. 11/30/2016 23:48'!
initialize
	|aForm|
	super initialize.
	aForm := ImageReadWriter formFromFileNamed: 'Chrysanthemum.jpg'.
	self newForm: aForm.
	self listOfEnemies: Set new.
	self swaplayer: nil.
	self worldSize: 3000.
	self extent: self worldSize asPoint.
	self center: (World bounds corner x / 2)@(World bounds corner y / 2).
	self openInWorld.
	self color: Color transparent.
	self clipSubmorphs: true.
	
	
! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies
	^ listOfEnemies! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies: anObject
	listOfEnemies := anObject! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'Tc 12/2/2016 16:02'!
step
	self checkForBorderCollisions.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'Tc 12/2/2016 16:02'!
stepTime
	^100! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer
	^swaplayer.! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer: x
	swaplayer := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:31'!
worldSize
	^worldSize! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:32'!
worldSize: anObject
	worldSize := anObject! !
